package org.fuseri.model.dto.exercise;

import jakarta.validation.constraints.NotBlank;
import jakarta.validation.constraints.NotNull;
import lombok.AllArgsConstructor;
import lombok.Getter;
import org.fuseri.model.dto.common.DomainObjectDto;

import java.util.Objects;

@AllArgsConstructor
@Getter
public class AnswerDto extends DomainObjectDto {

    @NotBlank
    private String text;

    @NotNull
    private boolean correct;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        AnswerDto answerDto = (AnswerDto) o;

        if (correct != answerDto.correct) return false;
        return Objects.equals(text, answerDto.text);
    }

    @Override
    public int hashCode() {
        int result = text != null ? text.hashCode() : 0;
        result = 31 * result + (correct ? 1 : 0);
        return result;
    }
}
